/************************************************************
*
*
*	Header containing all type declarations.
*
*	by Adrian Bool in cooperation with Graham Cox.
*
*	copyright  phantasm coding 1992.
*
*
************************************************************/

/* main types */

typedef unsigned short addressType;
typedef unsigned short wordType;
typedef unsigned short biggestType;
typedef char str255[255];
typedef wordType rBlock[255];

/* object types */

typedef wordType **oStHandle;

typedef struct
	{
	short version;
	addressType startAddress;
	long size;
	wordType **storage;
	addressType position;
	addressType address;
	}
	object;

typedef object **oHandle;

/* source types */

typedef char **sStHandle;
typedef char sName[21];

typedef struct
	{
	SFReply	fileSpec;
	sStHandle storage;
	long size;
	long caret;
	long line;
	}
	source;
	
typedef source **sHandle;

/* label types */

typedef char lName[8];
typedef unsigned int lValue;

struct lInfo
	{
	lName name;
	lValue value;
	struct lInfo **next;
	};

typedef struct lInfo label , **lHandle;

/* assemble types */

typedef struct
	{
	sHandle sourceCode;
	oHandle objectCode;
	lHandle labelHeader;
	}
	program;
	
typedef program **pHandle;


/* opcode types */

	
typedef enum 
	{
	nul = 0,
	
	and,
	tad,
	isz,
	dca,
	jms,
	jmp,
	io,
	
	cll,
	cma,
	cml,
	iac,
	rar,
	ral,
	rtr,
	rtl,
	nop,
	
	sma,
	sza,
	snl,
	spa,
	sna,
	szl,
	cla,
	osr,
	hlt,
	
	org,
	equ,
	end,
	data,
	store
	} opcode;