#ifndef NIL
#define		NIL 0L
#endif
#ifndef standardResID
#define		standardResID	128
#endif

typedef struct
{
	struct line	**nextLine;		/* handle to following link, or NIL */
	struct line	**lastLine;		/* handle to preceeding link, or NIL */
	Str255  theLine;			/* the characters on the line */
}line, *linePtr, **lineHdl;

/* note that last field is allocated dynamically- contains only the number of bytes
	required to hold the string plus the length count in position 0. DO NOT ACCESS
	this field unless you are using the routines provided to get it- you will fail! */

typedef struct
{
	Handle			undoBuffer;			/* handle to undo data */
	int				undoWhat;			/* what to undo (indicates type) */
	int				uSelStart;			/* selection start position */
	int				uSelEnd;			/* selection end */
	int				uLineID;			/* line to be undone */
	int				uNLines;			/* number of lines in multiple undo */
	int				undoFlags;			/* various flags, used internally */
}
undoRec, *undoPtr, **undoHdl;

	
typedef struct
{
	lineHdl	 		listHead;			/* handle to line 1 */
	lineHdl	 		listTail;			/* handle to last line */
	int				linesSelected;		/* number of lines highlighted apart from current */
	int		 		endSelChar;			/* character offset of selection end */
	int		 		lineHeight;			/* lineheight of current font */
	int		 		descent;			/* descent of current font */
	int				mSpace;				/* width of 'm' character in pixels for font */
	int		 		nLines;				/* number of lines in record */
	int		 		curEdLin;			/* which line contains cursor */
	int				topLine;			/* first line shown in window */
	int				linesInWindow;		/* num visible lines in window */
	int				charsAcross;		/* num visible 'm' spaces across window */
	WindowPtr 		owner;				/* pointer to window owning this record */
	ControlHandle	vScroll;			/* copy of vertical bar handle */
	ControlHandle	hScroll;			/* copy of horizontal bar handle */
	TEHandle		lineEditRec;		/* handle to textedit for line being edited */
	undoHdl			undoData;			/* Handle to info for undoing things */
	int				tabHeight;			/* height of tab bar- set to 0 to hide it */
	int				tabs[10];			/* character positions of tabs set */
	SFReply			asmFile;			/* file to be assembled */
	long			hiliteLine;			/* highlighted line, 0 means no highlight */
} textRecord, *textEdPtr, **textEdHdl;

#define 	EditWindowKind	11		/* kind ID for editor windows */
#define		TabBarHeight	28		/* height of tab ruler bar in window subframe */

#define		cantUndo		-1
#define		undoTyping		0
#define		undoClear		1
#define		undoPaste		2
#define		undoReformat	3
#define		undoTabs		4
#define		undoLineDelete	5
#define		undoLineInsert	6

